<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_decoder_kernel_1 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__decoder__kernel__1.html">entropy_decoder_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__decoder__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_decoder_kernel_1 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a58ccf28762eea1d9f361b9f0e91ad935"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__decoder__kernel__1.html#a58ccf28762eea1d9f361b9f0e91ad935">entropy_decoder_kernel_1</a> ()</td></tr>
<tr class="separator:a58ccf28762eea1d9f361b9f0e91ad935"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a41e6fac54159d5d1afe4d62a8512f02d"><td class="memItemLeft" align="right" valign="top"><a id="a41e6fac54159d5d1afe4d62a8512f02d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a41e6fac54159d5d1afe4d62a8512f02d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0994a466f265eb0711e3ff68086f80f"><td class="memItemLeft" align="right" valign="top"><a id="ac0994a466f265eb0711e3ff68086f80f"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_stream</b> (std::istream &amp;in)</td></tr>
<tr class="separator:ac0994a466f265eb0711e3ff68086f80f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6012b600335792d62e3133d4522b4a1d"><td class="memItemLeft" align="right" valign="top"><a id="a6012b600335792d62e3133d4522b4a1d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>stream_is_set</b> () const</td></tr>
<tr class="separator:a6012b600335792d62e3133d4522b4a1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9375a98ca2a213ced39c4b2894c64090"><td class="memItemLeft" align="right" valign="top"><a id="a9375a98ca2a213ced39c4b2894c64090"></a>
std::istream &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_stream</b> () const</td></tr>
<tr class="separator:a9375a98ca2a213ced39c4b2894c64090"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53323bb9bef267f3778793a4132f9bc7"><td class="memItemLeft" align="right" valign="top"><a id="a53323bb9bef267f3778793a4132f9bc7"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>decode</b> (uint32 low_count, uint32 high_count)</td></tr>
<tr class="separator:a53323bb9bef267f3778793a4132f9bc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b784f65f6f112c0e1d66abec97f262d"><td class="memItemLeft" align="right" valign="top"><a id="a7b784f65f6f112c0e1d66abec97f262d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>get_target_called</b> () const</td></tr>
<tr class="separator:a7b784f65f6f112c0e1d66abec97f262d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abfc0214c72235e4eb6e3c4b936d447d8"><td class="memItemLeft" align="right" valign="top"><a id="abfc0214c72235e4eb6e3c4b936d447d8"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>get_target</b> (uint32 total)</td></tr>
<tr class="separator:abfc0214c72235e4eb6e3c4b936d447d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a849d5ce30f8ff115072eac1e47049f9f"><td class="memItemLeft" align="right" valign="top"><a id="a849d5ce30f8ff115072eac1e47049f9f"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_decoder_kernel_1</b> (<a class="el" href="classdlib_1_1entropy__decoder__kernel__1.html">entropy_decoder_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a849d5ce30f8ff115072eac1e47049f9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a885d5a8ef585dca6010ad8c692499cad"><td class="memItemLeft" align="right" valign="top"><a id="a885d5a8ef585dca6010ad8c692499cad"></a>
<a class="el" href="classdlib_1_1entropy__decoder__kernel__1.html">entropy_decoder_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__decoder__kernel__1.html">entropy_decoder_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a885d5a8ef585dca6010ad8c692499cad"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a6be830ca89a1e85a4a2b30e9676fe2bd"><td class="memItemLeft" align="right" valign="top"><a id="a6be830ca89a1e85a4a2b30e9676fe2bd"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_low</b></td></tr>
<tr class="separator:a6be830ca89a1e85a4a2b30e9676fe2bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74d2b437496747f31f6665ccad625402"><td class="memItemLeft" align="right" valign="top"><a id="a74d2b437496747f31f6665ccad625402"></a>
const uint32&#160;</td><td class="memItemRight" valign="bottom"><b>initial_high</b></td></tr>
<tr class="separator:a74d2b437496747f31f6665ccad625402"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f1c44b96d8cc494b1e31f194d3ad500"><td class="memItemLeft" align="right" valign="top"><a id="a7f1c44b96d8cc494b1e31f194d3ad500"></a>
std::istream *&#160;</td><td class="memItemRight" valign="bottom"><b>in</b></td></tr>
<tr class="separator:a7f1c44b96d8cc494b1e31f194d3ad500"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83e86fe3ca3eb98f4dc794714423766d"><td class="memItemLeft" align="right" valign="top"><a id="a83e86fe3ca3eb98f4dc794714423766d"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>low</b></td></tr>
<tr class="separator:a83e86fe3ca3eb98f4dc794714423766d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d92aa8a3de8f6ec5a459add094a45d8"><td class="memItemLeft" align="right" valign="top"><a id="a7d92aa8a3de8f6ec5a459add094a45d8"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>high</b></td></tr>
<tr class="separator:a7d92aa8a3de8f6ec5a459add094a45d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb2956da1a93df51c5a257eddca742c7"><td class="memItemLeft" align="right" valign="top"><a id="abb2956da1a93df51c5a257eddca742c7"></a>
unsigned char&#160;</td><td class="memItemRight" valign="bottom"><b>buf</b></td></tr>
<tr class="separator:abb2956da1a93df51c5a257eddca742c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a918977a61abb18f01825fa59e31e7078"><td class="memItemLeft" align="right" valign="top"><a id="a918977a61abb18f01825fa59e31e7078"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>buf_used</b></td></tr>
<tr class="separator:a918977a61abb18f01825fa59e31e7078"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3a34b61673cb68a8788f93cfb8eca26"><td class="memItemLeft" align="right" valign="top"><a id="aa3a34b61673cb68a8788f93cfb8eca26"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>target</b></td></tr>
<tr class="separator:aa3a34b61673cb68a8788f93cfb8eca26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a09241489280a5bbc57ab1ed6b9867db9"><td class="memItemLeft" align="right" valign="top"><a id="a09241489280a5bbc57ab1ed6b9867db9"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>r</b></td></tr>
<tr class="separator:a09241489280a5bbc57ab1ed6b9867db9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ab6b38e5a12a1238bfa66c129cbad83"><td class="memItemLeft" align="right" valign="top"><a id="a7ab6b38e5a12a1238bfa66c129cbad83"></a>
std::streambuf *&#160;</td><td class="memItemRight" valign="bottom"><b>streambuf</b></td></tr>
<tr class="separator:a7ab6b38e5a12a1238bfa66c129cbad83"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a58ccf28762eea1d9f361b9f0e91ad935"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a58ccf28762eea1d9f361b9f0e91ad935">&#9670;&nbsp;</a></span>entropy_decoder_kernel_1()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dlib::entropy_decoder_kernel_1::entropy_decoder_kernel_1 </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">GENERAL NOTES
    this decoder is implemented using arithmetic coding

INITIAL VALUE
    in       == 0
    buf_used == 0
    buf      == 0
    initial_low      == 0x00000001  (slightly more than zero)
    initial_high     == 0xffffffff  (slightly less than one, 0.99999999976717)
    target   == 0x00000000  (zero)
    low      == initial_low
    high     == initial_high
    r        == 0

CONVENTION
    if (in != 0)
         in       == get_stream()
        true      == stream_is_set()
        streambuf == in-&gt;rdbuf()
    else
        false   == stream_is_set()

    buf      == used to hold fractional byte values which are fed to target.  
    buf_used == the number of low order bits in buf that are currently 
                in use
    low      == the low end of the range used for arithmetic encoding.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so it is
                always in the range [0,1)

                low is also never allowed to be zero to avoid overflow
                in the calculation (high-low+1)/total.

    high     == the high end of the range - 1 used for arithmetic encoding.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so when we
                interpret high as a real number then it is always in the
                range [0,1)

                the range for arithmetic encoding is always 
                [low,high + 0.9999999...)   the 0.9999999... is why
                high == real upper range - 1

    target  ==  32 bits of the fraction produced from an arithmetic encoder.
                this number is used as a 32bit fixed point real number. 
                the point is fixed just before the first bit, so it is
                always in the range [0,1)      

    r       ==  the value (high-low+1)/total from the last call to 
                get_target() or 0 if get_target_called() should be false

    get_target_called() == (r != 0)
</pre><p>! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="entropy__decoder__kernel__1_8h_source.html">entropy_decoder_kernel_1.h</a></li>
<li>entropy_decoder_kernel_1.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
